const nqp = require('nqp-runtime');
const oldRun = nqp.run;

const oldArgs = nqp.args;

nqp.run = function(code) {
  nqp.run = oldRun;
  return code;
};

let passedArgs;

nqp.args = function(calledFrom) {
    if (calledFrom.parent === module) {
        return passedArgs.map(arg => new nqp.NativeStrArg(arg));
    }
    return oldArgs(calledFrom);
};

const code = require('./nqp-bootstrapped.js');

//console.log('code:', code);

const core = require('nqp-runtime/core.js');

module.exports = function(source) {
    passedArgs = ['nqp-js', '--target=js', source];
    console.log('running');

    const oldWritefh = nqp.op.getstdout().constructor.prototype.$$writefh;
    let output;
    nqp.op.getstdout().constructor.prototype.$$writefh = function(buf) {
      output = core.toRawBuffer(buf).toString();
    }
    code();
    nqp.op.getstdout().constructor.prototype.$$writefh = oldWritefh;
    return output;
};

   
